<!DOCTYPE html>
<html class="writer-html5" lang="en" >
<head>
  <meta charset="utf-8" />
  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  <title>scripts.multiple_candidates.scripts_select.a_select_multiple_candidates.run &mdash; RDstar_light  documentation</title>
      <link rel="stylesheet" href="../../../../../_static/pygments.css" type="text/css" />
      <link rel="stylesheet" href="../../../../../_static/css/theme.css" type="text/css" />
  <!--[if lt IE 9]>
    <script src="../../../../../_static/js/html5shiv.min.js"></script>
  <![endif]-->
  
        <script data-url_root="../../../../../" id="documentation_options" src="../../../../../_static/documentation_options.js"></script>
        <script src="../../../../../_static/jquery.js"></script>
        <script src="../../../../../_static/underscore.js"></script>
        <script src="../../../../../_static/_sphinx_javascript_frameworks_compat.js"></script>
        <script src="../../../../../_static/doctools.js"></script>
    <script src="../../../../../_static/js/theme.js"></script>
    <link rel="index" title="Index" href="../../../../../genindex.html" />
    <link rel="search" title="Search" href="../../../../../search.html" /> 
</head>

<body class="wy-body-for-nav"> 
  <div class="wy-grid-for-nav">
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >
            <a href="../../../../../index.html" class="icon icon-home"> RDstar_light
          </a>
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../../../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>
        </div><div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="Navigation menu">
              <ul>
<li class="toctree-l1"><a class="reference internal" href="../../../../../lib.html">lib package</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../../../scripts.html">scripts.multiple_candidates package</a></li>
</ul>

        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap"><nav class="wy-nav-top" aria-label="Mobile navigation menu" >
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../../../../../index.html">RDstar_light</a>
      </nav>

      <div class="wy-nav-content">
        <div class="rst-content">
          <div role="navigation" aria-label="Page navigation">
  <ul class="wy-breadcrumbs">
      <li><a href="../../../../../index.html" class="icon icon-home"></a> &raquo;</li>
          <li><a href="../../../../index.html">Module code</a> &raquo;</li>
      <li>scripts.multiple_candidates.scripts_select.a_select_multiple_candidates.run</li>
      <li class="wy-breadcrumbs-aside">
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
             
  <h1>Source code for scripts.multiple_candidates.scripts_select.a_select_multiple_candidates.run</h1><div class="highlight"><pre>
<span></span><span class="sd">&quot;&quot;&quot; Find and apply different requirements on multiple candidates</span>
<span class="sd">in a given ROOT file.</span>

<span class="sd">To remove all the multiple candidates from a ROOT sample, run</span>

<span class="sd">.. code-block::</span>

<span class="sd">    python ./scripts_selct/a_select_multiple_candidates/run.py \</span>
<span class="sd">        -i {inpath} -o {outpath} -t {tree_name} -muc_strat sc</span>

<span class="sd">where ``sc`` stands for single candidates. ``inpath`` and ``outpath`` are</span>
<span class="sd">the path of the input and output ROOT files, opened and saved using uproot.</span>
<span class="sd">``{tree_name}`` is the common name of the input and output ROOT files.</span>

<span class="sd">To only keep one multiple candidate for every multiple event, as it is</span>
<span class="sd">a random choice, you need to choose a random seed ``{seed}``.</span>
<span class="sd">(an integer, e.g., 20)</span>

<span class="sd">.. code-block::</span>

<span class="sd">    python ./scripts_selct/a_select_multiple_candidates/run.py -i {inpath}</span>
<span class="sd">    -o {outpath} -t {{tree_name} -muc_strat random --seed {seed}</span>

<span class="sd">Finally, the multiple candidate can be chosen as the one that minimises</span>
<span class="sd">or maximises some column:</span>

<span class="sd">.. code-block::</span>

<span class="sd">    python ./scripts_selct/a_select_multiple_candidates/run.py \</span>
<span class="sd">    -i {inpath} -o {outpath} -t {tree_name} \</span>
<span class="sd">    -muc_strat opt -c {opt_column} -b {opt_best}</span>

<span class="sd">where ``{opt_column}`` is the the column whose value is larger or lower</span>
<span class="sd">according to the quality or signal-likeness of the candidate, and</span>
<span class="sd">``opt_best`` is ``max`` or ``min`` according to whether ``{opt_column}`` must</span>
<span class="sd">be minimised or maximised.</span>

<span class="sd">Note that if ``{outpath}`` is not provided, it is automatically determined</span>
<span class="sd">from the {inpath}.</span>
<span class="sd">&quot;&quot;&quot;</span>
<span class="kn">import</span> <span class="nn">os.path</span> <span class="k">as</span> <span class="nn">op</span>
<span class="kn">import</span> <span class="nn">config</span>

<span class="kn">import</span> <span class="nn">pandas</span> <span class="k">as</span> <span class="nn">pd</span>
<span class="kn">import</span> <span class="nn">hashlib</span>

<span class="kn">from</span> <span class="nn">lib.handle.handle_sample</span> <span class="kn">import</span> <span class="n">merge_columns</span>
<span class="kn">from</span> <span class="nn">lib</span> <span class="kn">import</span> <span class="n">open_samples</span><span class="p">,</span> <span class="n">save_dataframe</span>
<span class="kn">from</span> <span class="nn">lib.inout.serial</span> <span class="kn">import</span> <span class="n">try_makedirs</span>
<span class="kn">from</span> <span class="nn">multiple_candidates</span> <span class="kn">import</span> <span class="n">mulcan</span>

<span class="kn">from</span> <span class="nn">multiple_candidates.definition</span> <span class="kn">import</span> <span class="n">columns</span>


<div class="viewcode-block" id="get_seed"><a class="viewcode-back" href="../../../../../scripts.multiple_candidates.scripts_select.a_select_multiple_candidates.html#scripts.multiple_candidates.scripts_select.a_select_multiple_candidates.run.get_seed">[docs]</a><span class="k">def</span> <span class="nf">get_seed</span><span class="p">(</span><span class="n">base_seed</span><span class="p">:</span> <span class="nb">int</span><span class="p">,</span> <span class="n">hash_key</span><span class="p">:</span> <span class="nb">str</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="nb">int</span><span class="p">:</span>
    <span class="sd">&quot;&quot;&quot; Get a ``seed`` from a ``base_seed`` and a string.</span>

<span class="sd">    Args:</span>
<span class="sd">        base_seed: common seed</span>
<span class="sd">        hash_key: a string</span>

<span class="sd">    return:</span>
<span class="sd">        seed: random seed</span>

<span class="sd">    Notes:</span>
<span class="sd">        It allows to get a different seed for each file, parametrised by</span>
<span class="sd">        a key, in order to have a different seed for each sample,</span>
<span class="sd">        but everytime the same.</span>

<span class="sd">        The result is the result of the hashing of `hash_key` with the</span>
<span class="sd">        key `base_seed`</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">return</span> <span class="nb">abs</span><span class="p">(</span>
        <span class="nb">int</span><span class="p">(</span>
            <span class="n">hashlib</span><span class="o">.</span><span class="n">blake2b</span><span class="p">(</span>
                <span class="n">hash_key</span><span class="o">.</span><span class="n">encode</span><span class="p">(),</span>
                <span class="n">key</span><span class="o">=</span><span class="nb">str</span><span class="p">(</span><span class="n">base_seed</span><span class="p">)</span><span class="o">.</span><span class="n">encode</span><span class="p">()</span>
            <span class="p">)</span><span class="o">.</span><span class="n">hexdigest</span><span class="p">(),</span>
            <span class="mi">16</span>
        <span class="p">)</span>
    <span class="p">)</span> <span class="o">%</span> <span class="mi">2</span><span class="o">**</span><span class="mi">32</span></div>


<span class="k">if</span> <span class="vm">__name__</span> <span class="o">==</span> <span class="s2">&quot;__main__&quot;</span><span class="p">:</span>
    <span class="n">inpath</span><span class="p">,</span> <span class="n">outpath</span><span class="p">,</span> <span class="n">tree_name</span><span class="p">,</span> <span class="n">strat</span><span class="p">,</span> <span class="n">base_seed</span><span class="p">,</span> <span class="n">opt_column</span><span class="p">,</span> <span class="n">opt_best</span> <span class="o">=</span> \
        <span class="n">mulcan</span><span class="o">.</span><span class="n">parser</span><span class="o">.</span><span class="n">get_result_gen_parser</span><span class="p">(</span>
            <span class="n">description</span><span class="o">=</span><span class="s2">&quot;Find and select the single candidates of a sample&quot;</span><span class="p">,</span>
            <span class="n">list_arguments</span><span class="o">=</span><span class="p">[</span>
                <span class="s2">&quot;inpath&quot;</span><span class="p">,</span> <span class="s2">&quot;outpath_opt&quot;</span><span class="p">,</span> <span class="s2">&quot;tree_name&quot;</span><span class="p">,</span>
                <span class="s2">&quot;muc_strat&quot;</span><span class="p">,</span> <span class="s2">&quot;base_seed&quot;</span><span class="p">,</span> <span class="s2">&quot;opt_column&quot;</span><span class="p">,</span> <span class="s2">&quot;opt_best&quot;</span>
            <span class="p">],</span>
        <span class="p">)</span>

    <span class="k">if</span> <span class="n">strat</span> <span class="o">==</span> <span class="s2">&quot;opt&quot;</span><span class="p">:</span>
        <span class="k">assert</span> <span class="n">opt_column</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">,</span> \
            <span class="s2">&quot;Column (argument `-c`) must be specified&quot;</span>

    <span class="k">if</span> <span class="n">outpath</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
        <span class="nb">print</span><span class="p">(</span><span class="s2">&quot;Output path is determined from input path&quot;</span><span class="p">)</span>
        <span class="kn">from</span> <span class="nn">multiple_candidates.mulcan.strategy</span> <span class="kn">import</span> <span class="n">MucStrat</span>
        <span class="n">mucStrat</span> <span class="o">=</span> <span class="n">MucStrat</span><span class="p">(</span>
            <span class="n">muc_strat</span><span class="o">=</span><span class="n">strat</span><span class="p">,</span> <span class="n">seed</span><span class="o">=</span><span class="n">base_seed</span><span class="p">,</span>
            <span class="n">opt_column</span><span class="o">=</span><span class="n">opt_column</span><span class="p">,</span> <span class="n">opt_best</span><span class="o">=</span><span class="n">opt_best</span>
        <span class="p">)</span>
        <span class="n">mulcan_subfolder</span> <span class="o">=</span> <span class="n">MucStrat</span><span class="o">.</span><span class="n">subfolder</span>
        <span class="n">outpath</span> <span class="o">=</span> <span class="n">op</span><span class="o">.</span><span class="n">join</span><span class="p">(</span>
            <span class="n">op</span><span class="o">.</span><span class="n">dirname</span><span class="p">(</span><span class="n">inpath</span><span class="p">),</span> <span class="n">mulcan_subfolder</span><span class="p">,</span>
            <span class="n">op</span><span class="o">.</span><span class="n">basename</span><span class="p">(</span><span class="n">inpath</span><span class="p">)</span>
        <span class="p">)</span>

    <span class="nb">print</span><span class="p">(</span><span class="s2">&quot;Input path:&quot;</span><span class="p">,</span> <span class="n">inpath</span><span class="p">)</span>
    <span class="nb">print</span><span class="p">(</span><span class="s2">&quot;Output path:&quot;</span><span class="p">,</span> <span class="n">outpath</span><span class="p">)</span>
    <span class="nb">print</span><span class="p">(</span><span class="s2">&quot;Tree name:&quot;</span><span class="p">,</span> <span class="n">tree_name</span><span class="p">)</span>

    <span class="n">file_name</span> <span class="o">=</span> <span class="n">op</span><span class="o">.</span><span class="n">basename</span><span class="p">(</span><span class="n">inpath</span><span class="p">)</span>
    <span class="n">seed</span> <span class="o">=</span> <span class="n">get_seed</span><span class="p">(</span><span class="n">base_seed</span><span class="p">,</span> <span class="n">file_name</span><span class="p">)</span>
    <span class="nb">print</span><span class="p">(</span>
        <span class="sa">f</span><span class="s2">&quot;Get new random seed from seed </span><span class="si">{base_seed}</span><span class="s2"> &quot;</span><span class="p">,</span>
        <span class="sa">f</span><span class="s2">&quot;and file name </span><span class="si">{file_name}</span><span class="s2">&quot;</span><span class="p">,</span> <span class="n">seed</span><span class="p">)</span>

    <span class="n">dataframe</span> <span class="o">=</span> <span class="n">open_samples</span><span class="p">(</span>
        <span class="n">inpath</span><span class="p">,</span> <span class="n">tree_name</span><span class="p">,</span>
        <span class="n">list_columns</span><span class="o">=</span><span class="n">config</span><span class="o">.</span><span class="n">list_loaded_columns</span>
    <span class="p">)</span>

    <span class="c1"># Define the column `runNumber_eventNumber` to identify an event</span>
    <span class="n">merge_columns</span><span class="p">(</span>
        <span class="n">dataframe</span><span class="p">,</span>
        <span class="n">columns</span><span class="o">.</span><span class="n">EVENT_COLUMNS_TO_LOAD</span><span class="p">,</span>
        <span class="n">merged_column</span><span class="o">=</span><span class="n">columns</span><span class="o">.</span><span class="n">EVENT_COLUMN</span>
    <span class="p">)</span>

    <span class="c1">#: Associates an event with its candidate multiplicity</span>
    <span class="n">series_event_mults</span> <span class="o">=</span> <span class="n">mulcan</span><span class="o">.</span><span class="n">events</span><span class="o">.</span><span class="n">get_event_multiplicities</span><span class="p">(</span>
        <span class="n">dataframe</span><span class="p">,</span> <span class="n">event_column</span><span class="o">=</span><span class="n">columns</span><span class="o">.</span><span class="n">EVENT_COLUMN</span>
    <span class="p">)</span>

    <span class="c1">#: Dataframe of single candidates</span>
    <span class="n">single_dataframe</span> <span class="o">=</span> <span class="n">mulcan</span><span class="o">.</span><span class="n">events</span><span class="o">.</span><span class="n">get_dataframe_single_candidates</span><span class="p">(</span>
        <span class="n">dataframe</span><span class="p">,</span> <span class="n">series_event_mults</span><span class="p">,</span> <span class="n">columns</span><span class="o">.</span><span class="n">EVENT_COLUMN</span>
    <span class="p">)</span>
    <span class="k">if</span> <span class="n">strat</span> <span class="o">==</span> <span class="s2">&quot;sc&quot;</span><span class="p">:</span>
        <span class="n">saved_dataframe</span> <span class="o">=</span> <span class="n">single_dataframe</span>

    <span class="k">else</span><span class="p">:</span>

        <span class="n">multiple_dataframe</span> <span class="o">=</span> <span class="n">mulcan</span><span class="o">.</span><span class="n">events</span><span class="o">.</span><span class="n">get_dataframe_multiple_candidates</span><span class="p">(</span>
            <span class="n">dataframe</span><span class="p">,</span> <span class="n">series_event_mults</span><span class="p">,</span> <span class="n">columns</span><span class="o">.</span><span class="n">EVENT_COLUMN</span>
        <span class="p">)</span>

        <span class="k">if</span> <span class="n">strat</span> <span class="o">==</span> <span class="s2">&quot;random&quot;</span><span class="p">:</span>
            <span class="n">filtered_multiple_dataframe</span> <span class="o">=</span> <span class="n">multiple_dataframe</span><span class="o">.</span><span class="n">groupby</span><span class="p">(</span>
                <span class="n">columns</span><span class="o">.</span><span class="n">EVENT_COLUMNS_TO_LOAD</span>
            <span class="p">)</span><span class="o">.</span><span class="n">apply</span><span class="p">(</span><span class="n">pd</span><span class="o">.</span><span class="n">DataFrame</span><span class="o">.</span><span class="n">sample</span><span class="p">,</span> <span class="n">n</span><span class="o">=</span><span class="mi">1</span><span class="p">,</span> <span class="n">random_state</span><span class="o">=</span><span class="n">seed</span><span class="p">)</span><span class="o">.</span><span class="n">reset_index</span><span class="p">(</span>
                <span class="n">drop</span><span class="o">=</span><span class="kc">True</span>
            <span class="p">)</span>
        <span class="k">elif</span> <span class="n">strat</span> <span class="o">==</span> <span class="s2">&quot;opt&quot;</span><span class="p">:</span>
            <span class="k">if</span> <span class="n">opt_best</span> <span class="o">==</span> <span class="s2">&quot;max&quot;</span><span class="p">:</span>
                <span class="n">filtered_multiple_dataframe</span> <span class="o">=</span> <span class="n">multiple_dataframe</span><span class="o">.</span><span class="n">loc</span><span class="p">[</span>
                    <span class="n">multiple_dataframe</span>
                    <span class="o">.</span><span class="n">groupby</span><span class="p">(</span><span class="n">columns</span><span class="o">.</span><span class="n">EVENT_COLUMN</span><span class="p">)[</span><span class="n">opt_column</span><span class="p">]</span><span class="o">.</span><span class="n">idxmax</span><span class="p">()</span>
                <span class="p">]</span>
            <span class="k">elif</span> <span class="n">opt_best</span> <span class="o">==</span> <span class="s2">&quot;min&quot;</span><span class="p">:</span>
                <span class="n">filtered_multiple_dataframe</span> <span class="o">=</span> <span class="n">multiple_dataframe</span><span class="o">.</span><span class="n">loc</span><span class="p">[</span>
                    <span class="n">multiple_dataframe</span><span class="o">.</span><span class="n">groupby</span><span class="p">(</span>
                        <span class="n">columns</span><span class="o">.</span><span class="n">EVENT_COLUMN</span><span class="p">)[</span><span class="n">opt_column</span><span class="p">]</span><span class="o">.</span><span class="n">idxmin</span><span class="p">()</span>
                <span class="p">]</span>

        <span class="n">saved_dataframe</span> <span class="o">=</span> <span class="n">pd</span><span class="o">.</span><span class="n">concat</span><span class="p">(</span>
            <span class="p">[</span><span class="n">filtered_multiple_dataframe</span><span class="p">,</span> <span class="n">single_dataframe</span><span class="p">]</span>
        <span class="p">)</span><span class="o">.</span><span class="n">reset_index</span><span class="p">(</span><span class="n">drop</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>

    <span class="c1"># elif strat == &quot;best_lab1_ENDVERTEX_CHI2NDOF&quot;:</span>
    <span class="c1">#     &quot;&quot;</span>

    <span class="c1"># Remove column that contains tuple of values</span>
    <span class="n">saved_dataframe</span><span class="o">.</span><span class="n">drop</span><span class="p">(</span><span class="n">columns</span><span class="o">.</span><span class="n">EVENT_COLUMN</span><span class="p">,</span> <span class="n">axis</span><span class="o">=</span><span class="mi">1</span><span class="p">)</span>
    <span class="n">try_makedirs</span><span class="p">(</span><span class="n">op</span><span class="o">.</span><span class="n">dirname</span><span class="p">(</span><span class="n">outpath</span><span class="p">))</span>
    <span class="n">save_dataframe</span><span class="p">(</span><span class="n">saved_dataframe</span><span class="p">,</span> <span class="n">outpath</span><span class="p">,</span> <span class="n">tree_name</span><span class="p">)</span>
</pre></div>

           </div>
          </div>
          <footer>

  <hr/>

  <div role="contentinfo">
    <p>&#169; Copyright .</p>
  </div>

  Built with <a href="https://www.sphinx-doc.org/">Sphinx</a> using a
    <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a>
    provided by <a href="https://readthedocs.org">Read the Docs</a>.
   

</footer>
        </div>
      </div>
    </section>
  </div>
  <script>
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script> 

</body>
</html>